/******************************************************************/
/* Dmodulateur FSK /dcodeur AX25          	    	Jsenlis   */
/* Envoyer le signal sur l'entre analogique AN7                  */
/* Toutes les trames reues  sont envoyes sur l'uart2            */ 
/******************************************************************/

#include "p30f6014.h"
#include "float.h"
#include "math.h"
#include "stdio.h"
#include "stdlib.h"

#define ModBuf_X(k) __attribute__((__section__(".xbss"),__aligned__(k)))
#define ModBuf_Y(k) __attribute__((__section__(".ybss"),__aligned__(k)))
#define PI 3.141592654
#define  Max 400					//N bits max..
#define N_FANION 0                 // 10 
extern float fcy;
float M=33;							//Nech par bit == Nb fe/fb
unsigned int MM=32;					//M-1 pour dsp
int COEFF=33;      					//nbre de decalages par bit
unsigned int NN=1;          		//echantillons par dcallage NN=floor(M/COEFF)
int Y[Max] ModBuf_Y(32); 			//coeff COS0 SIN0 COS1 et SIN1 
int X[Max] ModBuf_X(32); 			// echantillons
char WWW=0,oldW=0;
unsigned int WW10; 					//sauve W10
unsigned int WW8;					//sauve W8
float fe=26400,f0=1200,f1=2400,fb=1200;//1200 2200 1200 fe 39600  ou 26400
int A0=0,B0=0,C0=0,A1=0,B1=0,C1=0;
int cpte=0,cptb1=0,cpto=0; 			//compteur d'tats, de 1, d'octets;;
int nboct=0;
int a=1;       						//a 1 2 4 ...128 et WWW octet  calculer
int ext=1; 							//lsb=0=> bit d'extension ext=1 
int fanion=0,start=0;
int DC0=1;  						// pour dtecter
int DC,CC0,maxCC0,minCC0;			//diff. des fft
int CC1,maxCC1,minCC1;				//diff. des fft
int quot;

void init_adc(void);
float lit_adc(int n);
void envoi_mesures(void);

void precalculs()
	{float b=32766;
	int i;
	fe=26400;f0=1200;f1=2200;fb=1200;  	//fe 39600 26400
	M=fe/fb;MM=(unsigned int)M-1;
	COEFF=M;
	maxCC0=0,minCC0=0x7FFF;				//diff. des fft
	maxCC1=0,minCC1=0x7FFF;				//diff. des fft
	NN = floor(M/COEFF);
	for(i=0;i<=MM;i++)
		{Y[i]=(int)b*cos(i*2*PI*f0/fe);
		Y[i+MM+1]=(int)b*sin(i*2*PI*f0/fe);
		Y[i+2*MM+2]=(int)b*cos(i*2*PI*f1/fe);
		Y[i+3*MM+3]=(int)b*sin(i*2*PI*f1/fe);
		}
	}
void init_dsp()
	{int i;
	XMODSRT=(unsigned int) X;
	XMODEND=(unsigned int) X+2*MM+1;
	YMODSRT=(unsigned int) Y;
	YMODEND=(unsigned int) Y+4*2*(MM+1)-1;	//les sin et cos
	WW10=YMODSRT;
	WW8=XMODSRT;
	CORCON=CORCON|0x00A0;					//signed sat  
	CORCON=CORCON&0xfffC;					//shift unbiass
	MODCON=0xCFA8;
}
void adc_on()
		{asm("disi #10");
		asm("bclr IFS0,#11");
		asm("bset IEC0,#11");
		}
void adc_off()
		{asm("disi #10");
		T3CON=0x0000;
		asm("bclr IEC0,#11");
		}
void init_adc(void)
	{asm("disi #100");
	TRISD=0x0000;
	T3CON=0x8000;
	PR3=(unsigned int)(fcy/fe); 
	ADPCFG=0;
	ADCON2 = 0x0000; //pas de scan
	ADCON3 = 0x010A; //1Tad Tad=11Tcy/2
	ADCHS = 7;  	   //Ch7
	ADCSSL=0;		
	ADCON1 = 0x8146;  //signedfrac 8346 signedint 0x8146
	asm("bset ADCON1,#15");
	asm("bset IPC2,#12");
	asm("bset IPC2,#13");
	asm("bset IPC2,#14");
	asm("bclr IFS0,#11") ;
	asm("bset IEC0,#11") ;
	}
void pwm_on() //OC8==portD7
	{PR2=(unsigned int)(fcy/fe);
	OC8R=0;//PR2>>1;
	OC8RS=0;//PR2>>1;
	OC8CON=0x0006;
	T2CON=0x8000;
	}
void pwm_off() //OC8==portD7
	{OC8CON=0x0000;
	}
void DecodeAX25()
	{char c;
	adc_off();
	TRISF=0;
	precalculs();
	init_dsp();
	init_adc();
	pwm_on();
	while(c=toupper(lit_char())!=27){}
	pwm_off();adc_off();
	}	                           
void __attribute__((__interrupt__,__shadow__)) _ADCInterrupt(void)
{// Calculs sur une fentre glissante des amplitudes de f0 et f1
 // Changement de frquence = 0
 // Pas changement =1
 // Reconstitution des octets avec suppression des bits de bourrage	
 // Pas de contrle de validit des trames
	int i;	
	asm ("push.d W0");
	asm ("push.d W4");
	asm ("push.d W8");
	asm ("push.d W10");
	asm("push RCOUNT");
	asm("mov _MM,W1");;
	asm("mov _WW10,W10");	
	asm("mov _WW8,W8");
	asm("mov ADCBUF0,W0");
	asm("mov W0,[W8]");//lecture AN0
	asm("nop");
	asm("clr A,[W8]+=2,W4,[W10]+=2,W5");
	asm("repeat W1"); // MM+1 fois
asm("mac W4*W5,A,[W8]+=2,W4,[W10]+=2,W5");
	asm("sac.r A,W4");
	asm("clr A");
	asm("mpy W4*W4,A"); //au carre
	asm("sac.r A,W0");
	asm("mov W0,_A0");
    asm("clr A,[W8]-=2,W4,[W10]-=2,W5");
	asm("clr A,[W8]+=2,W4,[W10]+=2,W5");
	asm("repeat W1"); // MM+1 fois
asm("mac W4*W5,A,[W8]+=2,W4,[W10]+=2,W5");
	asm("sac.r A,W4");
	asm("clr A");
	asm("mpy W4*W4,A");
	asm("sac.r A,W0");
	asm("mov W0,_B0");
    asm("clr A,[W8]-=2,W4,[W10]-=2,W5");
	asm("clr A,[W8]+=2,W4,[W10]+=2,W5");
	asm("repeat W1"); // MM+1 fois
asm("mac W4*W5,A,[W8]+=2,W4,[W10]+=2,W5");
	asm("sac.r A,W4");
	asm("clr A");
	asm("mpy W4*W4,A");
	asm("sac.r a,W0");
	asm("mov W0,_A1");
//	asm("dec W1,W1");
    asm("clr A,[W8]-=2,W4,[W10]-=2,W5");
	asm("clr A,[W8]+=2,W4,[W10]+=2,W5");
	asm("repeat W1"); // MM fois
asm("mac W4*W5,A,[W8]+=2,W4,[W10]+=2,W5");
	asm("sac.r A,W4");
	asm("clr A");
	asm("mpy W4*W4,A");
	asm("sac.r a,W0");
	asm("mov W0,_B1");
	asm("mov W8,_WW8");	
	CC0=A0+B0;
	CC1=A1+B1;
	if (CC0>maxCC0) maxCC0=CC0;
	if (CC0<minCC0) minCC0=CC0;
	if (CC1>maxCC1) maxCC1=CC1;
	if (CC1<minCC1) minCC1=CC1;
	if((maxCC0-minCC0)>(2*(maxCC1-minCC1)))
		{CC1=CC1+CC1;
		}
	if((maxCC1-minCC1)>(2*(maxCC0-minCC0)))
		{CC0=CC0+CC0;
		}
	DC=CC0-CC1;
	if (DC*DC0>0)  //pas de chgt elect
		{cpte++;}
	else			//chgt elect ==>0
		{//cptb1=round(cpte/COEFF)-1; calcul du nombre de bits  1 avant le chgt : cptb1
		quot=cpte+(COEFF>>1);
		cptb1=-2;
		do	{quot=quot-COEFF;cptb1++;     
			}
		while(quot>=0);
		if (cptb1<0)
			{cpte++;
			}
		else
			{if(cptb1>6)
				{//erreur ou stop
				 cpto=0;start=0;ext=1;fanion=0;nboct=0;	
				}
				else 
				{for(i=1;i<=cptb1;i++)         //calculs de l'octet courant
					{cpto++;WWW=WWW+a;a=2*a;
					 if (cpto==1)
							{if ((ext==1)&&(start==1)&&(nboct>14))  
									{ext=0;				//si lsb  1 : plus de dcalage
									U2TXREG= '=';
									}
							}
					if (cpto==8)						//si 8 bits  
							{oldW=WWW;
							if (start==1)				//afficher 
								{//sortir ASCII
							    if(WWW>31)	
									{U2TXREG= WWW;}	
      							}
							cpto=0;a=1;WWW=0;nboct++;	
						//	if (nboct>300) {nboct=0;start=0;}
							}
					}
				if (cptb1==5)
					{//ignorer le 0 de bourrage
					}
				else
					{if (cptb1==6)				//fanion 
						{a=1;WWW=0;cpto=0;fanion++;oldW=0x7E;ext=1;nboct=0;
     				    U2TXREG= '_';
						}
					else
					    {if	((fanion>N_FANION)&&(oldW==0x7E)&&(cptb1==0))	//synchro dbut de trame 	
							{start=1;ext=1;fanion=0;cpto=0;nboct=0;
							//U2TXREG= '='; pour tests
							}
						if((cpto==0)&&(ext==1))
							{cpto++;a=1;WWW=0;
							}
						else
							{cpto++;a=a*2;
							if(cpto==8)
								{if(start==1)
									{while ((U2STA & 0x0100)==0){};
									oldW=WWW;					
						 			if(WWW>31)	
										{U2TXREG= WWW;}	
      									}
								cpto=0;a=1;WWW=0;nboct++;
							//	if (nboct>300) {nboct=0;start=0;}
								}
							}
						}
					}
				}
			cpte=0;cptb1=0;
			}
		DC0=-DC0;
		}
//PORTF=CC0>>8;			//pour test niveau
//PORTF=(ADCBUF0+2048); //pour test niveau
OC8RS=(ADCBUF0)+0x25E;   //sortie son PWM sur PORTD7
	asm("pop RCOUNT");
	asm ("pop.d W10");
	asm ("pop.d W8");
	asm ("pop.d W4");
	asm ("pop.d W0");
	asm("bclr IFS0,#11") ;
}

void __attribute__((__interrupt__)) _StackError(void)
	{envoi_chaine("Pile Overflow");
	}	
void __attribute__((__interrupt__)) _AddressError(void)
	{envoi_chaine("Adresse erreur");
envoi_int(WREG8);envoi_char('*');envoi_int(WREG10);
	}	
void __attribute__((__interrupt__)) _MathError(void)
	{envoi_chaine("math erreur");
	}	
