/******************************************************************/
/* Gnrateur de trames et modulateur AX25     	    	Jsenlis   */
/* Sortie pwm PORTD7  26400Hz  filtrer (1200 2200Hz)             */
/* Un filtre passe-haut (220n/10k) + passe-bas (1k/22n) suffisent */ 
/******************************************************************/

#include "p30f6014.h"
#include "float.h"
#include "math.h"
#include "stdio.h"
#include "stdlib.h"
extern const int   SINUS[1024];
extern float fcy;
extern float fe,f0,f1,fb;
int PAS1200= 47;  						//46,54   1211  avec fe=26400kHz           
int PAS2200= 85; 					 	//85,33   2191              
char CCH[256],ADRESSES[64],DONNEES[192];
int PAS,NCH,NSync;
int index1;                  			//index dans la table des SIN
extern int cpte,cptb1,cpto;  			//compteur d'tats, de 1, d'octets;;
int cptbit,cpt;							//compteurs d'chantillons par bit

/****************************************************************/
/*				PWM et Timer2 et interruption ON 				*/
/****************************************************************/
void genAX25_on(void)					
	{TRISD=0;
	T2CON=0x0000;
	OC8CON=0x0000;
	OC8R=0;
	OC8RS=0;
	OC8CON=0x0006;
	PR2=(unsigned int)((float)fcy/(float)fe);// 26,4kHz;
	asm("disi #20");
	asm("bset IPC1,#8");
	asm("bclr IPC2,#9");
	asm("bclr IPC2,#10");
	asm("bclr IFS0,#6");					//T2int..
	asm("bset IEC0,#6");
	T2CON=0x8000;
	asm("disi #00");	
}
/****************************************************************/
/*				PWM et Timer2 et interruption OFF 				*/
/****************************************************************/
void genAX25_off(void)						//PWM et Timer2 off
		{asm("disi #10");
		asm("bclr IEC0,#6"); 				//T2int off
		OC8CON=0x0000;
		T2CON=0x0000;
		asm("disi #0");
		}
/****************************************************************/
/*			Mise en trame des chaines reues par l'uart2		*/
/****************************************************************/
void TrameAX25(void)						
		{char c;
		int i;
		fe=26400;NSync=20;PAS=PAS1200;cpt=0;cpte=0;cptb1=0;cpto=0;cptbit=fe/1200;
		//genAX25_off();
		envoi_chaine("Champs d'adresses :\n\r");
		lit_chaine(ADRESSES);crlf();
		envoi_chaine("Champs de donnes :\n\r");
		lit_chaine(DONNEES);crlf();
		i=0;c=ADRESSES[i];
		while (c!=0)
			{CCH[i]=(c<<1);
			i++;c=ADRESSES[i];
			}
		CCH[i]=33;//impair
		NCH=i+1;
		i=0;c=DONNEES[i];
		while (c!=0)
			{CCH[i+NCH]=c;
			i++;c=DONNEES[i];
			}
		NCH+=i;
		genAX25_on();
		}

/****************************************************************/
/*				Modulation FSK par interruption 				*/
/****************************************************************/
void __attribute__((__interrupt__,__shadow__)) _T2Interrupt(void)
{ 	cpte++;
	if (cpte>cptbit) //bit suivant
		{cpte=0;
		if (NSync>0) //Synchro  (octets de syncho : 7E)
			{if (cpto==0 ||cpto==7)
				{if (PAS == PAS1200) PAS = PAS2200;
				 else PAS = PAS1200;
				}
			cpto++;
			if (cpto==8)
				{cpto=0;NSync--;
				}		
			}		
		else //data
			{if (cptb1==5)           				//bit stuffing
				{if (PAS == PAS1200) PAS = PAS2200;
				 else PAS = PAS1200;
				cptb1=0;
				}
			else
					{if(cpt<NCH)					//data
						{if ((CCH[cpt]&0x0001)==0 ) //bit  0
							{cpto++;cptb1=0; CCH[cpt]>>=1;
							if (PAS == PAS1200) PAS = PAS2200;
							 else PAS = PAS1200;
							}
						 else  						//bit  1
							{cptb1++;
							cpto++;CCH[cpt]>>=1;
							}
						
						if (cpto==8)				//un octet envoy 
							{cpto=0;cpt++;
							}
						}
					
					else 							//fin
						{	genAX25_off();
						}
					}
			}		
		} 
	//envoi de l'echantillon
	index1 = (index1 +PAS)%1024;
	OC8RS=SINUS[index1];
  	asm("bclr IFS0,#6") ;
}
